package com.jda.portfolio.infrastructure.base;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import java.util.Hashtable;

public class EJBClient {

	private static String[] JNDINAME = {
		"java:global/jboss-as-ejb-remote-app/CalculatorBean!org.jboss.as.quickstarts.ejb.remote.stateless.RemoteCalculator",
		"jboss-as-ejb-remote-app/CalculatorBean!org.jboss.as.quickstarts.ejb.remote.stateless.RemoteCalculator",  // stripped java:global/
		"java:app/jboss-as-ejb-remote-app/CalculatorBean!org.jboss.as.quickstarts.ejb.remote.stateless.RemoteCalculator",
		"jboss-as-ejb-remote-app/CalculatorBean!org.jboss.as.quickstarts.ejb.remote.stateless.RemoteCalculator", // stripped java:app/
		"java:module/CalculatorBean!org.jboss.as.quickstarts.ejb.remote.stateless.RemoteCalculator",
		"CalculatorBean!org.jboss.as.quickstarts.ejb.remote.stateless.RemoteCalculator",  // stripped java:module/
		"java:jboss/exported/jboss-as-ejb-remote-app/CalculatorBean!org.jboss.as.quickstarts.ejb.remote.stateless.RemoteCalculator",
		"jboss-as-ejb-remote-app/CalculatorBean!org.jboss.as.quickstarts.ejb.remote.stateless.RemoteCalculator", // stripped java:jboss/exported/
		"java:global/jboss-as-ejb-remote-app/CalculatorBean",
		"jboss-as-ejb-remote-app/CalculatorBean", // stripped java:global/
		"java:app/jboss-as-ejb-remote-app/CalculatorBean",
		"jboss-as-ejb-remote-app/CalculatorBean", // stripped java:app/
		"java:module/CalculatorBean",
		"CalculatorBean", // stripped java:module/
		"ejb:/jboss-as-ejb-remote-app/CalculatorBean!org.jboss.as.quickstarts.ejb.remote.stateless.RemoteCalculator"  // ejb format
	};
	
	private Hashtable<String, Object> jndiProps;
	
	public EJBClient() {
		jndiProps = new Hashtable<String, Object>();
        jndiProps.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
        jndiProps.put("java.naming.factory.initial","org.jboss.naming.remote.client.InitialContextFactory");
        jndiProps.put(InitialContext.PROVIDER_URL, "remote://localhost:4447");
        
        // needed for remote access
        jndiProps.put(Context.SECURITY_PRINCIPAL, "client");
        jndiProps.put(Context.SECURITY_CREDENTIALS, "password");
        
         // This is an important property to set if you want to do EJB invocations via the remote-naming project
        jndiProps.put("jboss.naming.client.ejb.context", true);
        
	}
	
    public void doLookups() {
    	for (int i = 0; i < JNDINAME.length; i++) {
			lookup(JNDINAME[i]);
		}
    }
	
    
    private void lookup(String name) {
    	System.out.println("Lookup name="+name);
    	
    	Context ctx = null;
        try {
			ctx = new InitialContext(jndiProps);
			Object ref = ctx.lookup(name);
			System.out.println("...Successful");
		} catch (NamingException e) {
			System.out.println("...Failed");
			//System.out.println(e.getMessage());
			e.printStackTrace();
		} finally {
			if (ctx != null) {
				try {
					ctx.close();
				} catch (NamingException e) {}
			}
		}
    }
    
    public static void main(String[] args) throws Exception {
    	EJBClient client = new EJBClient();
    	client.doLookups();
    	
    	System.out.println("Done!");
    }
    
}
